#include <stdio.h>

/* (a) podzadatak */

/* polinom se moze pogodnije zapisati kao p(x)=x*\sum_{i=0}^n (\sum_{j=0}^{i}a_{n-j})(x^2)^i */

double horner(double a[], int n, double x){
    double p=0, koef=0;
    int i,j;
    /* koeficijent uz x^(2i) ne moramo racunati svaki put ispocetka, prvo izracunamo koeficijent uz x^(2n) jer nam
    on prvi treba za hornera pa redom oduzimamo */
    for(j=0; j<=n; j++){
        koef+=a[j];
    }
    for(i=n; i>=0; i--){
        p=p*x*x+koef;
        koef-=a[n-i];
    }
    p*=x;
    return p;
}

/* (b) podzadatak */

void sort(double a[], int n, double x, int b[], int m){
    /* u polju pomocno spremamo rezultate evulacije polinoma p u tocki x po svim iteracijama iz b */
    double pomocno[m], temp1;
    int i,j, korak, temp2;
    pomocno[0]=x;
    for(i=1; i<=b[0]; i++){
        pomocno[0]=horner(a,n,pomocno[0]);
    }
    for(i=1; i<m; i++){
            /* primijetimo da je p^(b[i])(x)=p^(b[i]-b[i-1])(p^(b[i-1])(x)) pa je dovoljno pozvati funkciju horner
            b[i]-b[i-1] puta, al i uz početnu točku p^(b[i-1])(x) koju smo izracunali u prethodnom koraku- ta vrijednost pise
            u pomocno[i-1] */
        pomocno[i]=pomocno[i-1];
        korak=b[i]-b[i-1];
        for(j=1; j<=korak; j++){
            pomocno[i]=horner(a,n,pomocno[i]);
        }
    }

    /*ovime smo napravili ukupno b[0]+(b[1]-b[0])+...+(b[m-1]-b[m-2])=b[m-1] poziva funkcije horner */
    /*drugi nacin je redom racunati p^(1)(x), p^(2)(x),...,p^(m-1)(x) te upisivati na odgovarajuca mjesta u polju pomocno
    vrijednosti onih iteracija p^(i)(x) za koje se i pojavljuje u nizu b */

    /* sada sortiramo- potrebno je raditi promjene i u nizu pomocno! */
    for(i=0; i<m-1; i++){
        for(j=i+1; j<m; j++){
            if (pomocno[i]>pomocno[j] || (pomocno[i]==pomocno[j] && b[i]>b[j])){
                temp1=pomocno[i]; pomocno[i]=pomocno[j]; pomocno[j]=temp1;
                temp2=b[i]; b[i]=b[j]; b[j]=temp2;
            }
        }
    }
}

/* test primjer */

int main(){
    double a[2]={-3,1}, x=1;
    int b[3]={1,2,3}, n=1, m=3, i;
    sort(a,n,x,b,m);
    for(i=0; i<m; i++){
        printf("%d ", b[i]);
    }
    return 0;
}
