#include <stdio.h>

/* (a) podzadatak */

/* polinom se moze pogodnije zapisati kao q(x)=x*\sum_{i=0}^n (\sum_{j=n-i}^{n}c_{j})(x^3)^i */

double horner(double c[], int n, double x){
    double q=0, koef=0;
    int i,j;
    /* koeficijent uz x^(3i) ne moramo racunati svaki put ispocetka, prvo izracunamo koeficijent uz x^(3n) jer nam
    on prvi treba za hornera pa redom oduzimamo */
    for(j=0; j<=n; j++){
        koef+=c[j];
    }
    for(i=n; i>=0; i--){
        q=q*x*x*x+koef;
        koef-=c[n-i];
    }
    q*=x;
    return q;
}

/* (b) podzadatak */

void sort(double c[], int n, double x, int d[], int m){
    /* u polju pomocno spremamo rezultate evulacije polinoma p u tocki x po svim iteracijama iz b */
    double pomocno[m], temp1;
    int i,j, korak, temp2;
    pomocno[0]=x;
    for(i=1; i<=d[0]; i++){
        pomocno[0]=horner(c,n,pomocno[0]);
    }
    for(i=1; i<m; i++){
            /* primijetimo da je q^(d[i])(x)=q^(d[i]-d[i-1])(q^(d[i-1])(x)) pa je dovoljno pozvati funkciju horner
            d[i]-d[i-1] puta, al i uz početnu točku q^(d[i-1])(x) koju smo izracunali u prethodnom koraku- ta vrijednost pise
            u pomocno[i-1] */
        pomocno[i]=pomocno[i-1];
        korak=d[i]-d[i-1];
        for(j=1; j<=korak; j++){
            pomocno[i]=horner(c,n,pomocno[i]);
        }
    }

    /*ovime smo napravili ukupno d[0]+(d[1]-d[0])+...+(d[m-1]-d[m-2])=d[m-1] poziva funkcije horner */
    /*drugi nacin je redom racunati q^(1)(x), q^(2)(x),...,q^(m-1)(x) te upisivati na odgovarajuca mjesta u polju pomocno
    vrijednosti onih iteracija q^(i)(x) za koje se i pojavljuje u nizu d */

    /* sada sortiramo- potrebno je raditi promjene i u nizu pomocno! */
    for(i=0; i<m-1; i++){
        for(j=i+1; j<m; j++){
            if (pomocno[i]<pomocno[j] || (pomocno[i]==pomocno[j] && d[i]<d[j])){
                temp1=pomocno[i]; pomocno[i]=pomocno[j]; pomocno[j]=temp1;
                temp2=d[i]; d[i]=d[j]; d[j]=temp2;
            }
        }
    }

    return;
}

/* test primjer */

int main(){
    double c[2]={1,-1}, x=1;
    int d[3]={1,2,3}, n=1, m=3, i;
    sort(c,n,x,d,m);
    for(i=0; i<m; i++){
        printf("%d ", d[i]);
    }
    return 0;
}
