#include<stdio.h>
#include <stdlib.h>
#include <time.h>


void swap(char*c, char*d){
    char temp = *c;
    *c = *d;
    *d = temp;
}

int letiLetiLopta(int r){ //vraca nasumican broj iz segmenta [-r,r]
    int upper = r;
    int lower = -r;
    return (rand() % (upper - lower + 1)) +lower;
}

int imaLiJosPokemona(char S[], int n){ //provjeravamo ima li jos pokemona na stazi, vraca 1 ako ih ima, 0 ako ih nema
    for(int i = 0; i < n; ++i){
        if(S[i] == 'p') return 1;
    }

    return 0;
}

int bacanjePokeLopte(char S[], int n, char t, int k){

    int pozicija_trenera = 0, pozicija_pada_lopte;

    for( int i = 0; i < n; ++i){ //trazimo gdje je trener s oznakom t
        if(S[i] == t) {
            pozicija_trenera = i;
            break;
        }
    }
    if(pozicija_trenera + k >= n){ //lopta je izletjela sa staze s desne strane pa ju vracamo na kraj staze
        pozicija_pada_lopte = n-1;
    } 

    else if(pozicija_trenera + k < 0){ //lopta je izletjela sa staze s lijeve strane pa ju vracamo na pocetak staze
        pozicija_pada_lopte = 0;
    }

    else{
        pozicija_pada_lopte = pozicija_trenera+k;
    }

    if(S[pozicija_pada_lopte] == 'p'){ //ulovili smo pokemona
        S[pozicija_pada_lopte] = '*';
        return 1;
    }
    else if(S[pozicija_pada_lopte] == 'b') return -1; //pogodili smo suca

    else return 0;

    

}


int natjecanje(char S[], int n, int brP, char*t){
    int br_ulovljenih_pokemona_a = 0, br_ulovljenih_pokemona_m = 0;
    int rez;
    char na_redu = *t;
    char nije_na_redu = ((na_redu == 'm') ? 'a' : 'm'); 
    int br_bacenih_lopti;
    for(br_bacenih_lopti = 0; br_bacenih_lopti < 2*brP; ++br_bacenih_lopti){
        rez = bacanjePokeLopte(S,n,na_redu,letiLetiLopta(n));
        if(rez == -1){
            printf("Pogodjen je sudac\n\n");
            break;
        }
        else if(rez == 1){ //netko je ulovio pokemona
            if(na_redu == 'm') br_ulovljenih_pokemona_m+=1;
            else br_ulovljenih_pokemona_a += 1;
        }
        if(!imaLiJosPokemona(S,n)) break; //nema vise pokemona na stazi
        swap(&na_redu, &nije_na_redu); // u sljedecem bacanju, baca drugi trene
    }
    if( rez == -1){ //sudac je pogođen
        *t = nije_na_redu;
        if(nije_na_redu == 'm') return br_ulovljenih_pokemona_m;
        else return br_ulovljenih_pokemona_a;
    }

    if(br_ulovljenih_pokemona_a == br_ulovljenih_pokemona_m){ //ash i misty su ulovili isti broj pokemona
        printf("jednak broj ulovljenih pokemona\n\n");
        *t = '*';
        return -1;
    }
    *t = (br_ulovljenih_pokemona_m > br_ulovljenih_pokemona_a) ? 'm': 'a'; //imamo pobjednika
    return (*t == 'm') ? br_ulovljenih_pokemona_m: br_ulovljenih_pokemona_a;
}


// za testiranje

int main(void){
    srand(time(NULL));
    int n = 40;
    char S[40];
    for( int i = 0; i < n; ++i) S[i] = '*';
    S[13] = 'm';
    S[26] = 'a';
    S[33] = 'b';
    for( int i = 0; i < n; ++i){
        if(S[i]!= 'm' && S[i] != 'a' && S[i] != 'b' &&letiLetiLopta(n) >= -n/5) S[i] = 'p';
    }
    printf("Stanje staze na početku\n\n");
    for( int i = 0; i < n; ++i)
        printf("%c  ", S[i]);
    printf("\n");
    char t = 'm';
    int l = 6;
    int br_pokemona = natjecanje(S, n, l, &t);
    if(br_pokemona == -1) 
        printf("Nema pobjednika\n\n");
    else
        printf("Pobjednik je trener %c i uhvatio je %d pokemona\n\n", t, br_pokemona);
    
    printf("Stanje staze na kraju\n");
    for( int i = 0; i < n; ++i)
        printf("%c  ", S[i]);
    printf("\n");
    return 0;
}