#include<stdio.h>
#include <stdlib.h>
#include <time.h>


void swap(char*c, char*d){
    char temp = *c;
    *c = *d;
    *d = temp;
}

int letiLetiMreza(int r){ //vraca nasumican broj iz segmenta [-r,r]
    int upper = r;
    int lower = -r;
    return (rand() % (upper - lower + 1)) +lower;
}

int imaLiJosMeduza(char D[], int n){ //provjeravamo ima li jos meduza u dolini, vraca 1 ako ih ima, 0 ako ih nema
    for(int i = 0; i < n; ++i){
        if(D[i] == 'm') return 1;
    }
    return 0;
}

int bacanjeMreze(char D[], int n, char l, int a){

    int pozicija_lovca = 0, pozicija_pada_mreze;

    for( int i = 0; i < n; ++i){ //trazimo gdje je lovac s oznakom l
        if(D[i] == l) {
            pozicija_lovca = i;
            break;
        }
    }
    if(pozicija_lovca - a >= n){ // mreza je izletjela iz doline s desne strane pa ju vracamo na kraj
        pozicija_pada_mreze = n-1;
    } 

    else if(pozicija_lovca - a < 0){ // mreza je izletjela iz doline s lijeve strane pa ju vracamo na pocetak
        pozicija_pada_mreze = 0;
    }

    else{
        pozicija_pada_mreze = pozicija_lovca - a;
    }

    if(D[pozicija_pada_mreze] == 'm'){ //ulovili smo meduzu
        D[pozicija_pada_mreze] = '*'; //mjesto postaje prazno
        return 1;
    }
    else if(D[pozicija_pada_mreze] == 'k') return -1; //pogodili smo suca

    else return 0;

}


int natjecanje(char D[], int n, int brM, char*l){
    int br_ulovljenih_meduza_s = 0, br_ulovljenih_meduza_p = 0;
    int rez;
    char na_redu = *l;
    char nije_na_redu = ((na_redu == 's') ? 'p' : 's'); 
    int br_bacenih_mreza;
    for(br_bacenih_mreza = 0; br_bacenih_mreza < 2*brM; ++br_bacenih_mreza){
        rez = bacanjeMreze(D ,n, na_redu,letiLetiMreza(n));
        if(rez == -1){
            printf("Pogodjen je sudac\n\n");
            break;
        }
        else if(rez == 1){ //netko je uhvatio meduzu
            if(na_redu == 's') br_ulovljenih_meduza_s+=1;
            else br_ulovljenih_meduza_p += 1;
        }
        if(!imaLiJosMeduza(D,n)) break; //nema vise meduza u dolini
        swap(&na_redu, &nije_na_redu); // u sljedecem bacanju, baca drugi lovac
    }
    if( rez == -1){ //sudac je pogođen
        *l = nije_na_redu; //pobjednik je lovac koji nije pogodio suca
        if(nije_na_redu == 's') return br_ulovljenih_meduza_s;
        else return br_ulovljenih_meduza_p;
    }

    if(br_ulovljenih_meduza_p == br_ulovljenih_meduza_s){ // spuzvabob i patrik ulovili su isti broj meduza
        printf("Jednak broj ulovljenih meduza\n\n");
        *l = '*';
        return -1;
    }
    *l = (br_ulovljenih_meduza_s > br_ulovljenih_meduza_p) ? 's': 'p'; // imamo pobjednika
    return (*l == 's') ? br_ulovljenih_meduza_s : br_ulovljenih_meduza_p;
}


// za testiranje

int main(void){
    srand(time(NULL));
    int n = 40;
    char D[40];
    for( int i = 0; i < n; ++i) D[i] = '*';
    D[13] = 's';
    D[26] = 'p';
    D[33] = 'k';
    for( int i = 0; i < n; ++i){
        if(D[i]!= 's' && D[i] != 'p' && D[i] != 'k' && letiLetiMreza(n) >= -n/5) D[i] = 'm';
    }
    printf("Stanje staze na početku\n");
    for( int i = 0; i < n; ++i)
        printf("%c  ", D[i]);
    printf("\n\n");
    char l = 's';
    int brM = 6;
    int br_meduza = natjecanje(D, n, brM, &l);
    if(br_meduza == -1) 
        printf("Nema pobjednika\n\n");
    else
        printf("Pobjednik je lovac %c i uhvatio je %d meduza\n\n", l, br_meduza);
    
    printf("Stanje staze na kraju\n");
    for( int i = 0; i < n; ++i)
        printf("%c  ", D[i]);
    printf("\n");
    return 0;
}